/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// OperationRequestLimit - struct for OperationRequestLimit
type OperationRequestLimit struct {
	LimitRequest *LimitRequest
}

// LimitRequestAsOperationRequestLimit is a convenience function that returns LimitRequest wrapped in OperationRequestLimit
func LimitRequestAsOperationRequestLimit(v *LimitRequest) OperationRequestLimit {
	return OperationRequestLimit{
		LimitRequest: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *OperationRequestLimit) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into LimitRequest
	err = newStrictDecoder(data).Decode(&dst.LimitRequest)
	if err == nil {
		jsonLimitRequest, _ := json.Marshal(dst.LimitRequest)
		if string(jsonLimitRequest) == "{}" { // empty struct
			dst.LimitRequest = nil
		} else {
			match++
		}
	} else {
		dst.LimitRequest = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.LimitRequest = nil

		return fmt.Errorf("data matches more than one schema in oneOf(OperationRequestLimit)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(OperationRequestLimit)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src OperationRequestLimit) MarshalJSON() ([]byte, error) {
	if src.LimitRequest != nil {
		return json.Marshal(&src.LimitRequest)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *OperationRequestLimit) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.LimitRequest != nil {
		return obj.LimitRequest
	}

	// all schemas are nil
	return nil
}

type NullableOperationRequestLimit struct {
	value *OperationRequestLimit
	isSet bool
}

func (v NullableOperationRequestLimit) Get() *OperationRequestLimit {
	return v.value
}

func (v *NullableOperationRequestLimit) Set(val *OperationRequestLimit) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationRequestLimit) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationRequestLimit) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationRequestLimit(val *OperationRequestLimit) *NullableOperationRequestLimit {
	return &NullableOperationRequestLimit{value: val, isSet: true}
}

func (v NullableOperationRequestLimit) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationRequestLimit) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
